### A-Shell Programmer’s Notepad ###

A-Shell Programmers’ Notepad, APN, is the preferred and recommended programming editor/environment for A-Shell. It consists of the open source Programmer’s Notepad 2 with associated configuration, definitions, extensions, etc., needed to make it suitable as an editor and development environment for A-Shell BASIC. 

This document is a work in progress and consists of two parts: User Guide and Development Notes. See the former for basic installation and usage, the latter for notes on how the product is evolving.

1. [License](License)
2. Installation
    1. [Download and Install Python 2.7.x](Installation-Python)
    2. [Download and Install A-Shell/Windows](Installation-AShell)
    3. [Download and Install APN](Installation-APN)  (see notes on [APN Environment Variable](APN Environment Variable))
    4. [Run APN](Run-APN)
    5. [Search For Extensions](Search-For-Extensions)
    6. [Configure Compiler](Configure-Compiler)
    7. [Test](Installation-Test)
    8. [Updates](Updates)
3. Usage
    1. [Creating a Project Group](Creating a Project Group)
    2. [Creating a Project](Creating a Project)
    3. [Workspaces](Workspaces)
    3. [Compiling a Program](Compiling a Program)
    3. [Navigating and Viewing Programs](Navigating and Viewing Programs)
    3. [Using Scripts](Using Scripts)
    3. [Jumping between Identifier References and Definitions](Jumping between Identifier References and Definitions)
    4. [Tags Explorer](Tags Explorer)	
    4. [Autocomplete](Using Autocomplete)
    4. [Call Tips](Using Call Tips)

4. [Configuration](Configuration)
    1. [View - Windows Configuration](View - Windows Configuration)
    1. [Creating Project Templates](Creating Project Templates)
    1. [Integrated Compilation](Integrated Compilation)
    1. [File Association - Recognition](File Association - Recognition)
    1. [Syntax Highlighting](Syntax Highlighting)
    1. [Scripts](Scripts)
    1. [Text Clips](Text Clips)
    1. [Python compiler-runtime integration](Python compiler-runtime integration)
    1. [Autocomplete](Autocomplete)
    1. [Call Tips](Configuring Call Tips)
    1. [Removing Unused Schemes](Removing Unused Schemes)
    1. [VUE Compatibility Mode](VUE Compatibility Mode)
    1. [Keyboard Shortcuts](Keyboard Shortcuts)
4. [Miscellaneous Notes](Miscellaneous Notes)
5. Development
	1. [LSM File](LSM File)
4. [Release Notes](Release-Notes)