Basic navigation within a single program file should be fairly intuitive if you’ve ever used any other Windows based editors. Such users can browse through the following material very quickly (although the first couple of tips about opening ++include files are worth a moment of attention). For those used to editing with VUE the following will give you quick intro into how a modern GUI editor can make your life much easier, without having to spend a lot of time mastering arcana.

To start with, let’s open up a project group. If you don’t have APN set to auto save/restore the workspace, you can find the previous project group in the Files > Recent Projects list or by just browsing to the projects directory where you stored it. From the list of programs you can then double-click one of them to open it.  For example:

![4.jpg](https://bitbucket.org/repo/dAyAyp/images/1948065433-4.jpg)

Now let’s open one of the include files, fnswitches.bsi. Depending on whether we added the sosfunc: directory to our project, we might be able to locate it easily in the projects window.  But even easier would be to click on the line and then enter Ctrl+Alt+o …  

![apnnav.png](https://bitbucket.org/repo/dAyAyp/images/668528446-apnnav.png)

and the specified file is opened and added to the tab list (if not already open):

![6.jpg](https://bitbucket.org/repo/dAyAyp/images/3212815022-6.jpg)

Now you can just click between the two program files by clicking the tab label.

The ability to open up several ++include files at once allows you to easily research or code changes that affect multiple files. But often you don't even know which ++include files may be related to the task at hand. In that case, one approach is to use the Search > Find In Current Program (with ++includes) option.  
Start by opening and setting the focus on the main program file. Then hit Ctrl+F and click on Find in Files, or Search > Find in Files; then select the Find in **Current Program (with ++includes)** option from the drop-down menu: 

![apn-fif3.png](https://bitbucket.org/repo/dAyAyp/images/412741218-apn-fif3.png)

In this mode, you probably want to set the File Types to *.* as shown above since you have already limited the search to just the current program. If searching the **Current Folder** or **Current Project Files**, then you may want to limit the File types to those containing source code (e.g. "*.bas, *.bsi, *.bp, *.map, *.def, *.sdf, ..."). 

The results appear in a new Find Results panel…

![91.jpg](https://bitbucket.org/repo/dAyAyp/images/4064290262-91.jpg)

You can then double-click any of the entries in the list to jump to it.

When working between two parts of a single file, such as a function body and a call to that function, it is sometimes useful to be able to see both at the same time.  To do this, use the Window > Split option, which opens two windows into the current file:

![92.jpg](https://bitbucket.org/repo/dAyAyp/images/3253215926-92.jpg)

Both windows are showing the same file, but as you can see from the line numbers along the left, there is a gap of about 300 lines between the two windows.

To go back to the normal view, use **Windows > Close View**. To do a similar thing with two different files, use **Window > Tile**

![93.jpg](https://bitbucket.org/repo/dAyAyp/images/2939726956-93.jpg)

You may have noticed that when you select a string, it automatically highlights other occurrences of the same string visible in the window:

![94.jpg](https://bitbucket.org/repo/dAyAyp/images/1818704517-94.jpg)

This optional feature is intended to help you visually identify other references to the same variable, since failure to notice one or more of them is a common cause of bugs. Especially when dealing with code like in the example above where there are many occurrences which are partly obscured by all of the punctuation, not to mention the visual similarity between SW(1) (not highlighted) and SW(I) (highlighted). If you don’t like the feature, you can turn it in Tools > Options:

![95.jpg](https://bitbucket.org/repo/dAyAyp/images/2866406196-95.jpg)

Once you've selected a token, you can search for additional instances of it by using Ctrl+F3 (forward) or Ctrl+Shift+F3 (backwards).