There are boilerplate snippets of text which can be inserted with a few keystrokes or mouse clicks, saving a lot of time otherwise spent typing frequently-repeated blocks of text (function headers, certain XCALLs, if/else/endif blocks, etc.)  Several have been pre-defined, but you may want to customize them and/or add your own.  Use **View > Windows > Text Clips** to display the Text Clips panel:

![1.png](https://bitbucket.org/repo/dAyAyp/images/3644807203-1.png)

Make sure that the language at the top is set to A-Shell Basic. Then use the buttons at the bottom of the panel to add/edit/delete/import. When creating text clips, you can optionally define a shortcut as an alternate way to insert the clip (type the shortcut and hit TAB).  Also, the text of the clip can contain variables:

        ${1} - first parameter (cursor lands here first)
        ${2} - second param (TAB takes you from one to the next)
        ${0} - place where final TAB leaves the cursor

To specify a default for any parameter, just append a colon and the text after the number within the brackets, as in this example:

![2.png](https://bitbucket.org/repo/dAyAyp/images/962976093-2.png)

To use the clip, enter the shortcut (“cb”) and hit TAB:

![3.png](https://bitbucket.org/repo/dAyAyp/images/194395953-3.png)

or double-click the clip in the text clip panel.  The clip is inserted and the cursor goes to the first parameter:

![4.png](https://bitbucket.org/repo/dAyAyp/images/1375753948-4.png)
 
... Type a comment ...

![5.png](https://bitbucket.org/repo/dAyAyp/images/450077430-5.png)
 
... Hit TAB again, and the cursor then lands at the position of the ${0}.

Text clips can also contain the following (hopefully self-explanatory) system variables:

    ${PN_Date}
    ${PN_Time}
    ${PN_Filename}
    ${PN_FileDirectory}
    ${PN_FilenameNoExt}
    ${PN_FilePath}
    ${PN_CurrentLine}
    ${PN_CurrentColumn}
    ${PN_CurrentWord}
    ${PN_CurrentLineText}
    ${PN_SelectedText}
    ${PN_CurrentProjectFile}
    ${PN_CurrentProjectGroupFile}
    ${PN_ProjectPath}
    ${PN_ProjectGroupPath}
    ${PN_ProjectName}
    ${PN_ProjectGroupName}
    ${PN_UseTabsYesNo}
    ${PN_TabSize}

For example,

![6.png](https://bitbucket.org/repo/dAyAyp/images/1924511798-6.png)

results in:

![7.png](https://bitbucket.org/repo/dAyAyp/images/2999040897-7.png)

**Extending text clip capabilities with scripts**

In addition to plain text and variables as described above, you can also execute scripts via the syntax:

`runScript(tchelpers.*scriptname*(*params*))`

where *scriptname* must be defined within the module scripts\tchelpers.py.  If that file does not exist, see the file scripts\tchelpers_example.py which contains a sample script and explanatory notes to help you get started. That file can be copied to tchelpers.py to enable the scripts within it (after closing and restarting APN). 

For example, if you don't like the date and time formats returned by the system variables ${PN_DATE} and ${PN_TIME}, you can enable the sample script printDateTime(mask) contained in the tchelpers_example.py file to output a format based on a mask you provide, e.g.:

![texclips2.png](https://bitbucket.org/repo/dAyAyp/images/4019295799-texclips2.png)

results in:

![textclips3.png](https://bitbucket.org/repo/dAyAyp/images/923288982-textclips3.png)

(See the tchelpers_example.py script for further details, including a link to the Python reference for the date/time masks.)

**Text clip storage**

Note that text clips, like most other configuration attributes, are user-specific and stored in %APPDATA%\Echo Software\PN2.  In this case they are in the asb sub-folder as asb.clips and asb-xcall.clips.

