### Updates ###

APN is, and will likely remain for some time, in a state of frequent updates and enhancement. To minimize the administrative overhead of making those updates available to interested developers, we've adopted the update mechanisms built-in to the Bitbucket repository system:

* Tortoise Hg (Mercurial)
* Zipped downloads

Each of these is described in further detail below.


#### Tortoise Hg ####

[Tortoise Hg](http://tortoisehg.bitbucket.org/) is a Windows GUI wrapper for the Mercurial revision control system widely used in the Linux world. The initial APN installation package comes with a Mercurial definition file, so basically all you need to do is install Tortoise Hg and then review the instructions in [Tortoise Hg Setup](TortoiseHg Setup). Then whenever you'd like to see and/or download the latest patches...

Launch Tortoise Hg and open your APN Repository. (The first time, use File > Open Repository and browse to the APN directory. Subsequently you can just pick it from your repository list on the left.)

View > Synchronize. The screen looks something like this:

![apn-repo-sync1.png](https://bitbucket.org/repo/dAyAyp/images/227517951-apn-repo-sync1.png)

Make sure the Post Pull: button (highlighted in yellow above) says "Update". (If not, change it.)  Also make sure the URL is as shown here:

![apn-repo-sync3.png](https://bitbucket.org/repo/dAyAyp/images/3422362607-apn-repo-sync3.png)

Then click the icon on the far left (check for incoming changes from selected URL). This causes Tortoise Hg to log into the microsabio/apn repository on bitbucket.org and check if there are any updates. If so, it will display something like this:

![apn-repo-sync2.png](https://bitbucket.org/repo/dAyAyp/images/2159571540-apn-repo-sync2.png)

Before updating, you should shut down any existing APN session(s).

Assuming you want to update, click the Accept button and it will be done. If you aren't sure, you can always click the Reject button and perhaps review the changes, Wiki notes, etc. in more detail by browsing to the repository (https://www.bitbucket.org/microsabio/apn).

Note: once you see how easy Tortoise Hg is to use for APN, you may be motivated to use it for your own source code. Besides the obvious benefit of helping you track changes to your own source code, another benefit for developers working across machines and platforms is that it is easy to clone the entire repository from one system to another (say, from Windows to Linux). We actually use this mechanism internally for compiling and testing A-Shell on different platforms.

#### Zipped Downloads ####
If you don't want to install Tortoise Hg, the other alternative is just to use the zipped downloads for updating. On the navigation panel at the left edge of the screen, you should see a **Downloads** link. This leads to a page that looks something like:

![apn-downloads.png](https://bitbucket.org/repo/dAyAyp/images/276081358-apn-downloads.png)

Clicking the **Download Repository** link leads to a standard browser download operation of a zip file containing the entire package. Once downloaded, you can open it in your favorite zip handler/extractor.  It is arranged in a directory tree something like this:

![apn-zip.png](https://bitbucket.org/repo/dAyAyp/images/3015200701-apn-zip.png)

All you have to do is extract the entire thing on top of your existing APN directory tree. (It will not overwrite any of your customized settings.)  NOTE HOWEVER:

* Be sure to close any existing APN sessions before unzipping the files.

* The ZIP contains a cryptic top level directory ("microsabio-apn-77...") in the example above, which is a kind of stand-in for your existing APN directory. In the typical ZIP extractor, you'll need to select that directory for extraction, and then point the extraction operation at your APN directory, so that the end result is that all the files and folders underneath the "microsabio-apn-77..." directory in the ZIP end up within the APN directory on your disk. A common mistake is to extract the ZIP such that you end up with the "microsabio-apn-..." folder on your disk, either at the top level of your C: drive or within the APN directory, which won't do you any good, as APN will continue to only recognize the files in the APN (e.g. C:\vm\APN) directory.


