Call Tags is an automatic feature that displays the prototype of a function, procedure, or XCALL, when you type the opening parenthesis or comma immediately preceding the argument list. For example:

![apn-basort.png](https://bitbucket.org/repo/dAyAyp/images/4201444776-apn-basort.png)

![apn-hex.png](https://bitbucket.org/repo/dAyAyp/images/1868982650-apn-hex.png)

![apn-b64.png](https://bitbucket.org/repo/dAyAyp/images/1118361733-apn-b64.png)

From a usage standpoint, there isn't much to know here. Just use the displayed prototype as a guide, or ignore it. But there are a few non-obvious details to be aware of:

* XCALL prototypes are manually defined (see [Configuring Call Tips](Configuring Call Tips)) and consequently may contain some variation in the syntax, including additional details such as the notes next to K1TYP and K1ORD in the BASORT example above. If you want your personal SBXs to be part of the Call Tags database, you'll have to manually add them.

* Function prototypes may either be added to the Call Tags database manually (static, as with the XCALLs), or automatically (by APN by extracting them from the program source code as the program is loaded). Those that are automatically created (as in FN'B64ENC'DECODE example above) will be limited to just what was contained in the actual FUNCTION or PROCEDURE definition. Those that are manually defined (as in the Fn'Dec2Hex() example above) may contain additional details, clues, etc. In particular, they may start with the name of the file that contains the function, since you may need to explicitly ++include it.

* You can re-display the Call Tips for a function previously entered into the source code by over-writing the opening paren or comma, e.g.

![apn-ac7.png](https://bitbucket.org/repo/dAyAyp/images/4053912780-apn-ac7.png)

**Note:** The Call Tags implementation was substantially improved in release 1.0.23