A workspace encapsulates a project group, one or more projects, and the set of open files (whether or not they are part of an open project). These are particularly handy when your task involves several different files, and you get interrupted by the need to work on a different set of files, but want to return later to where you were. However, like nearly every other time-saving feature, you have to make a choice about how best to use it, and the choice may involve a trade-off. To make it easier to identify the best choice, following is a brief description of the three typical editing styles:

### Ad Hoc (No Workspace) ###
If you’re used to VUE and are being dragged into the APN world, you probably want to just ignore workspaces. In other words, each time you launch APN, you can start with no files open, and the only status saved between editing sessions will be the state of the files you edited.  To get this effect, just turn off the **Tools > Options > General > Remember Open Files and Projects between Sessions** option. 

The main downside of this mode is that if you have to terminate an editing session at an inconvenient time (like to go home for dinner or need to reboot your PC), you would then have to re-open all the files again. On the other hand, in such a case you could use the **File > Save Workspace As** option to save your workspace before shutting down, and then **File > Open Workspace** to resume from where you left off. 

### Single / Continuous Workspace  ###
If you have a single working environment, and view every editing session as just a continuation of the previous one, then you’ll want to enable the **Tools > Options > General > Remember Open Files and Projects Between Sessions** option and otherwise forget about workspaces:

![77.jpg](https://bitbucket.org/repo/dAyAyp/images/3349209806-77.jpg)


This way you can always just close APN without much concern (it will prompt if necessary to save any files that have been modified) and come right back to where you were when you later relaunch it. 

Note that even if this is your normal mode, you can still launch APN in the Ad Hoc mode by specifying the --vue <filespec> command line switch. In that case, your ad hoc session will be independent of your standard workspace-enabled session.

The main downside of this mode is that unless you are diligent about closing files when you’re done with them, you’ll tend to accumulate a lot of open files, which will steadily increase the amount of time it takes to open APN (since it has to parse all those files as it opens).

### Multi-Project / Multi-Workspace  ###
If you tend to maintain multiple projects, and/or switch between multiple distinct program editing tasks, then you probably want to disable the **Tools > Options > General > Remember Open Files and Projects Between Sessions** option and instead manually open and close workspaces. The easiest way to keep track of these multiple workspaces will be to give them the same names as your project groups and/or projects, and store them in the same project directory where you store your projects and project group files (so they’re all conveniently in one place).  Each time you start a new APN session, you’ll have to manually use File > Open Workspace to open the desired workspace. (This will open the associated project group, project(s), and files in one step, so there’s a decent payoff for the one manual step. Plus, if you keep all your workspaces in the same folder, it will always open to that folder by default, allowing you to just double-click the workspace’s **.pnws** file.  When you close APN, it will ask if you want to save the modified files and the current project/project group file(s), and as long as you say Yes to that, it will automatically save the workspace back to the same workspace file that you opened. If you want to save it under a different name (to allow multiple workspaces for a single project), you can use the **File > Save Workspace** As option. 
