*Note: Prior to 1.0.23, Autocomplete was limited to internal functions, e.g. instr(). Release 1.0.23 expanded this to include the scheme keywords and labels / functions / defstructs extracted dynamically from your source code.*

See [Using Autocomplete](Using Autocomplete) for details on usage.

Autocomplete is enabled and configured via the Tools > Options > Autocomplete dialog:

![apn-ac6.png](https://bitbucket.org/repo/dAyAyp/images/1844975852-apn-ac6.png)

The first option enables/disable the feature entirely. The remaining options modify the behavior:

- Include scheme keywords means that the ASB language keywords (IF, THEN, READ, WRITE, WHILE, LOOP, etc.) will be included in the autocomplete mechanism. (You may want to exclude them if you know them all well enough, and type well enough, that they just amount to clutter.)

- Fold scheme keywords uppercase is relevant only if including the scheme keywords. Normally these are display in lower case. (Note that the matching logic is case-insensitive, but when you select a token from the list, it will be inserted into your source in the same case as it was displayed in the list.)

- Include source tags means that APN will scan your source code and automatically merge the function and procedure names, labels, and defstructs into the autocomplete database. This is probably the most useful part of the feature, so you almost certainly want to turn it on. 

- The Auto-Closed HTML tags option only relates to the HTML and XML schemes, and causes it to automatically insert a close tag immediately when you enter an open tag. For example, if you type "<bold>" it will immediately insert "</bold>" next to it.

The Trigger options determine when/if the autocomplete popup list will display. Note that the "after # characters" option does not prevent you from requesting the list after typing fewer characters. (So you might argue that even if you don't like the list popping up all the time, it might make more sense to just increase the minimum number of characters, to say, 6, than to select the "on request only" option.)  

**IMPORTANT NOTE:** regardless of which trigger option you select, when you request the list explicitly, the list will contain all the tokens that contain the substring typed (anywhere in the token). (In the image example above, this explains the inclusion of the last token in the list.)  When the list is triggered automatically, it will contain only tokens that start with the substring typed.

