The ability to compile programs and navigate directly to error lines without leaving the editing environment is one of the biggest time-savers of an integrated editor like APN (versus, say, VUE).  Here’s a quick example.

Start by loading a program (use File > Open, or pick one from your Projects window). We’ll use a program from the SOSLIB: here, xtx1.bp.

![1.jpg](https://bitbucket.org/repo/dAyAyp/images/2639207764-1.jpg)

Note that the program should be recognized as A-Shell Basic on the toolbar (highlighted above). If the toolbar is not visible, use View > Toolbar to enable it.

To compile, just hit F5 or use Tools > ASB Compile.  (This is for the default compiler configuration; if you defined a project-specific one, it may be F6 and would show up separately on the Tools menu.)  The output window at the bottom will display the results of the compilation:

![2.jpg](https://bitbucket.org/repo/dAyAyp/images/229331115-2.jpg)

If there are errors, they will show up in red, and you can click on them to jump to the file/line. To test that, scroll down in the file and insert some nonsense and hit F5 again to recompile:

![3.jpg](https://bitbucket.org/repo/dAyAyp/images/619559458-3.jpg)

Note: highlighting of the current line is optional, but very useful for this operation, since otherwise the caret is difficult to spot. (Making the source file line numbers visible, as in the above configuration, also helps, since the error line number is visible in the output window.)  Current line highlighting and line numbers can be enabled via **Tools > Options > Visual Help > Highlight current editor line** and **> Defaults > Show Line Numbers** , respectively.

If the compilation doesn’t work as just described, or you want to adjust the switches or other compiler options, see the **Integrated Compilation** topic in the **Configuration** section for notes on how it is configured.

### Auto-Switch to Main Program ###

New in 2.4.0.11 (see f611a3f), hitting the compile command key (e.g. F5) from within the context of an include file will automatically switch to the last-compiled main program and compile it instead. This is a very common situation, saving time and eliminating confusion (from otherwise trying to understand errors that occur when trying to compile a BSI as if it were a complete program).  For example, in the following image, we have multiple files open, with fnfilestr.bsi currently being edited:

![apn-compiler4.png](https://bitbucket.org/repo/dAyAyp/images/3060491497-apn-compiler4.png)

Assuming that we had previously compiled the associated main program (fnfilestr.bp), attempting to compile the bsi will auto-switch the focus to the main program and compile it instead:

![apn-compiler5.png](https://bitbucket.org/repo/dAyAyp/images/819292359-apn-compiler5.png)

Note that this feature doesn't try to analyze which include files go with which main programs. It just looks at the extension of the current file and compares it against the list of known ASB extensions (in %APN%\ctags\additionalLanguages.conf, currently set to **asbmain:.bas,.bp**).  If the current file extension is not in that list, it switches to the last compiled program in the current editing session, provided that it is still open. This covers the majority of the cases, where you are primarily working on one main program and several include files at one time. However it does make it difficult to really compile a program with a non-standard extension. Either you have to add that extension to the list of known extensions, or you have to close any other files which do have standard ASB extensions. (It will display a warning but proceed to compile anyway if there is no prior compiled program that is open.)  Add this to the list of reasons for sticking with standard file extensions!
