Files are associated with languages (or “schemes”) in three ways - by the file extension, by the contents of the start of the file, and by a configuration file used for generating tags used in the object (aka ctags) explorer.  Each is described separately below.

### Association by File Extension  ###

**Tools > Options > Files** leads to a dialog where you can add your special file extensions and associate them with A-Shell Basic.  The extensions .bp, .bas, .map, .bsi, .sdf and .def have been pre-associated:

![3.png](https://bitbucket.org/repo/dAyAyp/images/2409152369-3.png)

### Association by Pattern (SmartStart) ###

**Tools > Options > New Files** (aka SmartStart) allow you to define strings that particular file types are likely to start with, so they can be recognized if the extension isn’t. For example, A-Shell Basic programs typically start with a comment line (i.e. “!”) or a program statement (i.e. “program”  or “PROGRAM”), all of which have been pre-defined for you:

![4.png](https://bitbucket.org/repo/dAyAyp/images/3067025473-4.png)

To test this, use File > Open to open an ASB file and verify that it defaults to the A-Shell Basic scheme.

### Ctags ###

This also involves a list of file extensions provided to the ctags utility for the purpose of recognizing A-Shell Basic files and dividing them into main files (e.g. .bas and .bp) and auxiliary or include files (.e.g. .bsi etc). This list is stored in the file %APN%\ctags\additionalLanguages.conf file as follows:

--langmap=asb:.bas.bp.bsi.map.sdf.gen.bpi.lsx.def,python:+.pyw,asbmain:.bas.bp

The extensions following asb: and up to the comma are considered to be A-Shell Basic files of any type, while those following asbmain: and up to the next comma or end of line are considered main program files. If you use other extensions in your A-Shell Basic applications, you should add them one or both parts of the above list.  

Technical notes:

  * The asbmain: list isn’t actually part of the standard ctags configuration - it is an APN extension - but doesn’t conflict with standard ctags usage.)  

  * The python:+.pyw clause adds the pyw extension to the internal hard-coded list of Python extensions.

  * APN uses a copy of compil.exe renamed to ctags.exe as a front-end wrapper to the real ctags utility, which has been renamed to ctags_orig.exe. This isn’t important to know, unless for some reason you manually update either the compil.exe or ctags.exe components.