One of the most time-saving programming features of a development tool is the ability to compile programs without leaving the editor, and being able to jump directly from the compilation error report to the source code.  Although it has been pre-configured, you may want to edit the compiler switches, which you can do via **Tools > Options > Tools**:

![1.png](https://bitbucket.org/repo/dAyAyp/images/3508093782-1.png)

After clicking Edit, use the dialog to adjust your compiler switches. (Note that if the tool is missing, or if you want to add another variation of the compiler, just use the Add option.)

![2.png](https://bitbucket.org/repo/dAyAyp/images/3077798587-2.png)

Note that compil.exe is located in the APN directory (Command), and you can use the special variable %(APN) to refer to it, as shown above. (This syntax only applies here, not necessarily elsewhere.)  Also, it needs to reference the miame.ini which is probably in your miame directory (Parameters). The list above is truncated, but should be something like:

**-ini c:\vm\miame\miame.ini -x:2 -m -so -lsm “%d%f”**

The path to your miame.ini file may differ, and you may add or adjust the switches per your requirements, but you must include the **-so** switch (sends error information to stdout where it can be retrieved by the editor), **-lsm** (to ask the compiler to generate metadata used for APN scripts), and the **“%d%f”** which is the full filespec of the file being compiled.

Important notes on the miame.ini file specification:

* The switch to identify the miame.ini is **-ini** (not merely **-i** as in the case of the ashell command line switches).

* Since the specified miame.ini file will be processed frequently (each time a file is loaded, saved, or compiled), it makes sense to streamline it, removing anything that isn't needed by the compiler. (The essential statements are: SERIAL,CONAME,LANGUAGE,CONSOLE,DEVICE,ERSATZ). And you may want to trim your list of DEVICES to just those related to your source code. (Obviously this would entail making a copy of your original, standard miame.ini, perhaps calling the new one apn.ini). 

* Any path specifications in the ini file must be compatible with and relative to the Windows PC environment in which APN and the compiler are running in. (This can sometimes be a point of confusion if you are trying to share a copy of the miame.ini which is intended for another OS or network context.)

* Although APN can work directly with SAMBA-mounted files hosted by a UNIX system (provided you use the Windows directory notation - see prior point), SAMBA (and other P2P I/O) is much slower than I/O to a local Windows device, so your performance will not be as snappy. (This will be particularly noticeable when loading many files at once, and/or with programs that have many ++includes)

Then click on the Console I/O tab and enter the following:

![3.png](https://bitbucket.org/repo/dAyAyp/images/2222354667-3.png)

See [Compiling a Program](Compiling a Program) for notes on testing/using the compiler.

