### Release Notes ###

Note: the "release system" which was previously based on producing an install package for each numbered update, as documented above, has been somewhat replaced by just posting updates to the repository, which you can pull down by syncing to your own local repository, or generating a zip.  Consult the [commit list](https://bitbucket.org/microsabio/apn/commits/all) for details of changes since the last official "release".

#### 1.0.29 Release Notes ####
08-Oct-16 

* Installer refinement: should now work to install into other directories besides recommended c:\vm\apn
* Installer fix: was missing the scripts\tchelpers
* Installer refinement: VUE-compatible keyboard map now much more complete (^D,^F,^O,^Y,^Z now act as in VUE; use Shifted-versions for Windows-compatible commands; erase your old settings/keymap-vue.dat to activate new version.)

#### 1.0.28 Release Notes ####
06-Oct-16

* compil.exe/ctags.exe 6.3.781 - Numerous enhancements, new language features, etc. Corresponds to A-Shell 6.3.1531. Note: backward compatibility not possible if you incorporate new language features; otherwise it is automatic.

#### 1.0.27 Release Notes ####
06-Feb-16

* glue.py - now imports scripts\tchelpers.py if present, to allow for user extension of text clip capabilities via `runScript(tchelpers.scriptname(params))`

* tchelpers_example.py - provides example of how to create text clip helper scripts (see script source for details).


#### 1.0.26 Release Notes ####
03-Dec-15

* pn.exe 2.4.0.15 - revise call-tip/auto-complete database logic so that it doesn't reset the database except with all files are closed.  Previously it was resetting on every new file opened, which was having the effect of losing functions and labels that otherwise should have remained in the database.

#### 1.0.25 Release Notes ####
02-Dec-15

* compil.exe/ctags.exe 6.2.759 - fix issue #47 (new compiler-based tagging was failing to create independent tags for each include file). Note that for these ASB include files, we are reverting to using the generic tagger, so the tags shown for the include file by itself may not match exactly those shown for the include file within the main file.


#### 1.0.24 Release Notes ####
20-Oct-15

* compil.exe/ctags.exe 6.1.754 - fix problem with certain errors relating to unterminated code blocks reporting a wacky (over 4 billion) line number. 

* compil.exe/ctags.exe 6.1.755 - fix problem with variables below MAP1 not being tagged.

* compil.exe/ctags.exe 6.1.756 - begin "obeying" ++IFxxx directives during tagging.

* compil.exe/ctags.exe 6.1.757 - fix problem with labels preceded by line numbers not being tagged.

* compil.exe/ctags.exe 6.1.758 - (refinement to 6.1.756) ++IF, ++IFDEF and ++IFNDEF directives are now "obeyed" during tagging, but ++IFLBL, ++IFNLBL, ++IFMAP, ++IFNMAP, and their associated ++ELIFxxx and ++ELSE clauses are now ignored, i.e. all of the enclosed source code is tagged. This is a compromise between file loading/tagging speed and tagging accuracy; it eliminates the need to "compile" variables and labels during tagging, but might result in some objects being tagged that will be excluded by the compiler. Note that for the same reason, SIZEOF(var) will evaluate to zero during tagging.


#### 1.0.23 Release Notes ####
30-Sep-15

*Overall release now considered 1.0 rather than 0 as it is now in general release and fully supported.*

- pn.exe 2.4.0.14

1. Refinements to the workspace saving. Opened workspace name in a non-project context is now remembered on close. Remove warning about overwriting an existing workspace when saving. Fix failure to save workspace when files had been opened/closed but no changes made.

2. Autocomplete and Call Tips features now operational in ASB scheme. (Previously it was so limited as to be useless.) List of subject keywords starts with built-in functions and xcalls, may optionally include scheme keywords, functions/procedures (from tags list) and routines defined in %APN%\settings\asb.api (i.e. your site-specific XCALLs, SOSLIB routines, etc.) When auto-complete list manually invoked (CTRL+SPACE), matching is now "loose" (particularly useful for locating functions without knowing the exact name, i.e. 

![apn-ac4.png](https://bitbucket.org/repo/dAyAyp/images/1394201254-apn-ac4.png)

![apn-ac2.png](https://bitbucket.org/repo/dAyAyp/images/207292792-apn-ac2.png)

3. Refinements to tagger. Tagging operation is now considerably faster than before (up to 3X in local tests of large files). Locals variables have been removed from the variable tag list.

* compil.exe 6.1.751 - now handles the tagging operation internally (responsible for the performance and other improvements mentioned above.

* compil.exe 6.1.752 - fix spurious "invalid overlay" error on certain variations of overlay syntax within a defined structure.

* compil.exe 6.1.753 - fix memory corruption problems in very large compilations

* settings\sosfunc.api file now included; contains autocomplete/call-tips definitions for many of the SOSFUNC library functions. (Must renamed/copied to settings\asb.api to activate; or use as a model to create your own site-specific definitions.)

#### 0.22 Release Notes ####
17-Sep-15

- pn.exe 2.4.0.13    - Add option to the Find In Files dialog to search the current program and ++includes. Also, if the current scheme is ASB, the context menu Go To Definition and Comment options now link to the associated scripts.

![apnfif.png](https://bitbucket.org/repo/dAyAyp/images/1095222925-apnfif.png)

The new Find in Program (with ++includes) search option fills a gap in the otherwise extensive range of search capabilities. To use, open the main program file and put the focus on it before invoking the Search > Find in Files. Note that any files associated with the current program that are open and have been modified will be searched in memory rather than on disk.


#### 0.21 Release Notes ####
10-Sep-15

- pn.exe 2.4.0.12    - Add an option to the Options > Tools > General dialog to toggle between the standard and VUE keyboard maps. (see discussion below)
- vue.py 1.0.0 script added (to implement a few of the VUE-compatible functions that otherwise don't map one-to-one with internal APN functions.)
- compil.exe 6.1.750 - Fix bug (introduced in [748]) causing spurious "illegal map level" errors when using the ++PRAGMA EXTERN_BEGIN/END construct.

For the benefit of old-timers who are having difficulty adapting to the standard APN keyboard editing commands, we've now made it easy to switch between the standard keyboard map and the "VUE-friendly" version (by toggling the checkbox option in the Options > Tools > Default dialog). However, because some of the VUE editing commands (VEC) conflict with important, well-established and/or very-useful Standard Windows Editing Commands (SWEC), we made some compromises. (For example, ^Z and ^Y were deemed more useful as Undo / Redo than the old VEC delete line / delete EOL, so the release version of our VUE keyboard map doesn't remap those keys. Likewise with the clipboard commands.) But you can further customize the keyboard mapping to suit yourself (via Options > Tools > Keyboard). 

See the spreadsheet file \apn\doc\keymap-vec-swec.xls which summarizes the changes between the VEC and SWEC  keymaps.

Note: The two keyboard maps (the standard APN version and the VUE-friendly version) are now released as keymap.rel and keymap-vue-rel (in the \vm\apn\settings directory).  The working copies are keymap.dat and keymap-vue.dat. Updating from the repository will not change your working copies, but if the working copy of the file does not exist, it will be created from the .rel copy.  You can also manually copy the .rel over to the .dat to revert back to the original keyboard map (if your customization attempts go awry).

#### 0.20 Release Notes ####
31-Aug-15

- compil.exe 6.1.749 - fix bug (introduced in [745]) where a mapped overlay @var would incorrectly look for a subscripted var if the previous MAP statement was subscripted.
- compil.exe 6.1.748 - Flag MAP2+ w/o prior unterminated MAP1 as illegal map level
- compil.exe 6.1.747 - Fix compilation bug related to variable initializers in map statements
- compil.exe 6.1.746 - Fix EFS conflict (compil was crashing under EFS)
- compil.exe 6.1.745 - Fix problem with diallowing valid subscripted overlays in structures
- compil.exe 6.1.744 - Check for dimx a(x),type,byref error x not -1 /jdm

- Default keymap now maps ^J/^K down/up, ^T/^R to PgDn/PgUp (for the benefit of people used to VUE). Note that ^H typically maps to Search/Replace, and ^L typically maps to delete line; you can customize those in the Tools > Keyboard dialog.

- Update Scintilla (editor control) from version 3.4.3 to 3.6.0. Probably no obvious differences for most users, but new version does have some minor bug fixes and is more compact. See the [Scintilla website](http://scintilla.org/) for detailed release notes.

#### 0.19 Release Notes ####
24-Jul-15

- compil.exe 6.1.743 - fix bug relating to initializer within defstruct
- compil.exe 6.1.742 - support ordmap(varstr;varx), .ISNULL(var)


#### 0.15 Release Notes ####
26-Aug-14

- compil.exe 6.1.697 - fix spurious complaints about illegal overlays. (Fixes #10)
- compil.exe 6.1.698 - compiler version now displayed in APN output window
- compil.exe 6.1.699 - fix ++ELIFMAP/ELIFDEF/ELIFLBL (bogus error if first clause false) (Fixes #19) 
- compil.exe 6.1.700-705 - LSM improvements to support new Show Structure script.
- Show Structure (^alt+S) script reintroduced (display still preliminary)
- Note: you must add the -lsm switch to your compile command lines in order for the new Show Structure script (and quite possibly other scripts) to work. You can remove the -lsx switch as it is no longer used by APN and may slow down your compilations during editing if you have large programs. (You may want to have a special release-compile command for your final release which replaces the -lsm with -lsx since the LSX file is just as useful as ever for tech support purposes.)
- Install package now includes Tortoise Hg repository (see wiki Beta Updates section for details)


#### 0.14 Release Notes ####
19-Aug-14

- pn.exe 2.4.0.10 Fix crash on loading workspace w/o project group. Remove <APNDIR>\<ppg> directory on workspace close (previously was only on APN exit).


#### 0.13 Release Notes ####
12-Aug-14

- pn.exe 2.4.0.9 Revise directory layout for compiler auxiliary output files now stored in %TEMP%\APN\%APNPID%.  Env var %APNPID% containing process id created. pn.PID() API call added to PYPN interface to return process id.
- pypn.dll 2.4.0.9 support new pn.PID() API call.
- ctagsnavigator 1.6.0.4 support for new %APNPID% env/dir
- compil.exe/ctags.exe 6.1.695 various refinements to the lsx and bug fixes in the compiler
- Scripts directory contents totally rearranged, refactored, various improvements in the operation of the existing scripts. (SF)
- Includes script patches thru commit ["942a0c5"](https://bitbucket.org/stephenfunkhouser/apn/commits/942a0c53f9528cb3a7a688a55f4e87d8f7585cf3 ) (on Bitbucket APN repository)

#### 0.12 Release Notes ####
21-Jul-14

- compil.exe (and ctags.exe) 6.1.688 fix problems with $COPY (reporting spurious errors or actual errors on wrong line #).  Fix problems with @overlays within structures (were generating syntax errors if nested or within arrays).  Changes to support structure display logic.  
- object tagger bug fix: was tagging map statements (variables) that were actually commented out (ctags\additionalLanguages.conf).
- Goto Definition script improvement: was failing to locate array variables if the array was not explicitly mapped as an array (i.e. if the variable was an array by virtue of being part of a higher-level array).  It was also failing to 
- Comment end-of-line script refinement (SF)
- Add Show Structure script. Note that this requires the main program to have been compiled with the -lf switch. The structure display is currently just text in a message box; there are future plans for a more sophisticated columnar display.
- pn.exe 2.4.0.8:  minor adjustment to help menu


#### 0.11 Release Notes ####
14-Jul-14

- compil.exe (and ctags.exe) 6.1.683 fix problem processing ++ conditionals with undefined or non-constant symbols
- Fix problem with config.xml path reference getting out of sync when moving APN from one directory to another. (The path reference now gets reset by running the installer/updater.)
- Comment end-of-line script improvements now resets position of existing comments and supports multiple (selected) lines. (SF)
- Comment script refinement (both block toggle and end-of-line) normalize variations in selection ending position to behave more intuitively. (Previously it only really worked right when the selection ending position was at the start of the next line.)
- Add usersettings_example.py as example of a private user settings file rename to usersettings.py to put into use, i.e. to override settings in settings.py. (Note that usersettings.py is not ovewritten by updates.)
- Add .fpn, .bpi, .stru, .mav, and .bav extensions to extmap.dat (extensions associated with A-Shell Basic in Tools > Options > Files)
- pn.exe 2.4.0.7:
	- Change: default directory for workspace files (.pnws) is now %APN%/settings.  This seems logical since they are associated with the user, perhaps even more so than other user settings. Users are advised to move their existing .pnws files to the \settings directory to save time when opening/saving workspaces. 
	- Refinement: Display waiting cursor while loading project


#### 0.10.1 Release Notes ####
07-Jul-14

- pn.exe 2.4.0.6 bug fixes…
- startup crash related to null workspace pointer
- When opening a project rather than a workspace, the subsequent Workspace Save As dialog no longer contains the double extension .ppg.pnws
- Remove some references to projects and directories from the MicroSabio environment from the default config.xml and UserSettings.ini files


#### 0.10 Release Notes ####
06-Jul-14

- compil 6.1.682, ctags.6.1.682  various bug fixes/refinements
- pn.exe 2.4.0.5, pypn.dll 2.4.0.4
- Double-clicking on an identifier now selects the full identifier name (previously it stopped at apostrophes.
- Add xcalls to the object/ctag explorer.
- Add an onDocClose() event handler to glue.py
- Search (^F) and Goto Line (^G)  now call the PushPosition script (to allow use of the Go-Back script to get back to the original position after searching).
- asb_scripts.py addition: Go To Top and Go To Bottom scripts added, to act as wrappers for CTRL+HOME and CTRL+END which first call PushPosition allow Go-Back.  You’ll have to manually add add the keyboard shortcuts (Tools > Options > Keyboard) for the two scripts in order to complete the implementation as intended, i.e. to allow CTRL+HOME, followed by CTRL+ALT+B to return to the original position.
- Backup files (enabled in Tools > Options > General) now use the VUE standard scheme of replacing the extension with .bak (rather than appending an additional .bak extension).
- Workspace handling refinement: When the option to remember open files between sessions (Tools > Options > General) is disabled and you manually open a workspace, it will auto-save that workspace on exit (if you answer ok to the prompt to save the project/files on exit). If you didn’t open a workspace, then it will prompt you to save one. (See the re-written section above on Workspaces).


#### 0.9 Release Notes ####
30-Jun-14

- compil.exe 6.1.676 fixes a non-APN-related bug related to distinguishing structures when the name of one is a subset of the name of the other.  
- compil.exe 6.1.677 fixes error reporting for missing include files, to show the location of the actual failed include statement, rather than the top level include statement.  Also fixes problems processing the last line of a file if there is no trailing CRLF. 
- compil.exe 6.1.678 improves reporting of missing ++endif (now lists the stack of ++if locations with unmatched ++endif).  Fix problem with auto $COPY prog.ver.  Fix problem with includes files lacking a trailing CRLF on the last line.
- Add Comment End Of Line script (from Stephen Funkhouser). To use it, manually add the keyboard shortcut CTRL+SHIFT+1 (in Tools > Options > Keyboard); you may also want to set the default column number for the comment marker by editing the file %APN%\scripts\settings.py (and then exiting/relaunching APN).
- Add more extensions to the list of those tagged as A-Shell Basic.

#### 0.8 Release Notes ####
27-Jun-14

- compil.exe (and ctags.exe) 6.1.675.1 adjusts the Tags Explorer organization to show just the top level of ++includes (in the Modules section), and to create Tag groups for each open auxiliary file. (Previously tags were only generated for the main program files.) 
- Script bug fix:  filespec case sensitivity problems were causing failure of the Go To Definition script in some ++include files.
- Script bug fix: Go To Definition script now handles identifiers ending with $.
- Add documentation for Tags Explorer


#### 0.7 Release Notes ####
26-Jun-14

- compil.exe (and ctags.exe) 6.1.675 automatically includes <prog>.VER on first $COPY statement; fixes problem with parsing last line of files not containing a final NL terminator.
- script fix: Trace/Debug now handles struct.member variables; Debug.After was acting as Before
- Replace Goto Var script with Goto Identifier Def script and improve in several ways; no longer necessary to select the identifier, just put the cursor somewhere on it.
- Add Push/Go-Back/Go-Forward scripts and integrate with Open ++Include and Goto Identifier Def scripts to allow returning back to the original position.
- Several fixes to the Tags Explorer 
- Because the navigational script commands are most convenient when given via keyboard shortcuts (because they don’t interfere with the focus), I’ve added suggested shortcuts to the script navigator, all of which consist of CTRL+ALT+char, abbreviated as ^alt+char.  However, since shortcuts are part of the local user configuration, this update does not overwrite them, so it is recommended that you either manually code the shortcuts to match, using Tools > Options > Shortcuts, or if you don’t like the suggested shortcuts, post a message in the forum to see if we can all agree on common shortcuts for these central functions.
- Add Jumping between Identifier References and Definitions section to doc.

#### 0.6 Release Notes ####
21-Jun-14

The installation program now installs “APN Documentation” (instead of “APN Online Documentation”) and “APN Extension Finder” (instead of “Find APN Extensions”). The new names are so all the APN items will sort together. You must manually remove the old items from the APN program group.

- compil.exe (and ctags.exe) 6.1.674 updates the $COPY search paths and also inserts line #0 in errors that aren’t otherwise line oriented (like missing label), so that they get recognized and highlighted as errors
- remove the “this is OnDoLoad” messages appearing in the output window when loading a file.
- remove a few exotic language files from the install package just to reduce package size
- installer now checks if an instance of APN is running and makes you close it first
- installer give option to create a desktop shortcut and to display doc/notes (this doc)
- asb_scripts.py was missing from prior package
- add several Madics-related extensions to the list of extensions treated as ASB for purposes of tagging and syntax highlighting. Complete list (in ctags\additionalLanguages.conf) is now:
- .bas.bp.bsi.map.sdf.gen.bpi.lsx.def.sub.cpy.siz.get.upd.opn.dsp.scr


#### 0.5 Release Notes ####
20-Jun-14

- compil.exe (and ctags.exe) 6.1.673 fixes a problem in which it was crashing while processing local struct.member references
- SciLexer.dll 3.4.3.0 (update from 2.2.3.0). This probably has no effect (yet) but was mainly a test to make sure that we could independently update to the latest version of this module (which will come into play subsequently).
- asb scripts.py renamed to asb_scripts.py (the space in the file names was deemed a problem)
- fix bug in open ++include script when include fspec was followed by tab characters


#### 0.4 Release Notes ####
18-Jun-14

- compil.exe (and ctags.exe) 6.1.671: now supports Madics $COPY (similar to ++include but with different search path); relax restriction on having a local structure with name matching global structure (error triggered only if structure types not the same and you try to access a member in global structure). Don’t set up tags for non-main files independent of the main file. Force compiler and tagger to set current directory to match main file to fix problems with failure to resolve ++include specs when not running from a miame directory.
- pn.exe 2.4.0.3: --vue mode no longer forces a separate instance.  If you want that, add --allowmulti switch.
- additionalLanguages.conf updated to fix problems with tags containing unexpected comment markers
- asb scripts.py functions to open 1 include or all includes improved in various minor ways.
- new script “Goto var definition” similar to context menu function but multi-file.
- toggle comment block script now works on current line if no selection

#### 0.3 Release Notes ####
17-Jun-14

- compil.exe (and ctags.exe) 6.1.669:
	- Remove the .OBJ and preserve the .RUN when just tagging the file (as opposed to really compiling it).  
	- Fixes tag file line terminator problem which resulted in the last tag being ignored.
- pn.exe 2.4.0.2:
	- deletes the %temp%\curproj.lst file on entrance (except in multi-instance mode), eliminating some confusion if a session using projects & templates is followed by one using just files.
	- new command line switch --vue allows you to launch a separate instance to quickly edit a single file (as you would vue.lit), ignoring the current save/restore workspace options.   Syntax:  pn --vue filespec
	- ctags explorer is now able to match up the tagged object to the file that it came from, so you should be able to double-click on a label or function and jump to it whether it is in the current file or not.
- ctagsnavigator 1.6.0.2:
	- picks up the file associated with the tagged object
	- resolves a problem with TAB characters in the source confusing the tagging
- script to open ++includes fixes/enhancements:
	- fixes a problem with case sensitivity on the file name
	-  is now a bit more robust, handling the case where a ++include has no tags and thus wasn’t previously found in the main file’s .tags file.
- asb.schemedef updated for a few missing keywords (such as exitfunction)
- additionalLanguages.conf updated to process Labels better.


#### 0.2 Release Notes ####
16-Jun-14

- New APN installer (apn-0.2.exe) automatically fixes the config.xml reference to the install directory, preserves existing settings when updating.
- Document procedure for creating project-specific compiler configurations
- Compil.exe (and ctags.exe) 6.1.668.1 now locates the project-specific compil command line (and in particular the -ini spec) if applicable.
- ctags_orig.exe 5.8.0.1 minor adjustments to eliminate conflicts with some built-in language support and to establish ability to recompile (and possibly enhance it).
- pn.exe 2.4.0.1 now creates a file, %TEMP%\curproj.lst whenever a project is loaded or set as the active project. 
- ctagsnavigator.dll 1.6.0.1 (no actual changes yet, just establish ability regenerate.)
- Add Labels to the object explorer
- Add .sub and .cpy to the list of ASB file extensions (for object tagging purposes).



#### 0.1 Release Notes ####
10-Jun-14
This is the very first attempt to package APN in a way to allow a few intrepid developers to experiment with it. The package is installed as a zip file, along several manual steps outlined in the next section. The end result, hopefully, is an editing environment, which while still short of ideal, is good enough for most programmers to start using productively and that can serve as a base to solicit feedback and build on.

Here’s a quick overview of the working features:

- Modern multi-file multi-window editor
- Recognize A-Shell Basic files (by extension and pattern)
- Integrated compiler
- Syntax highlighting
- Simple project management
- Workspaces
- Text clips
- Object explorer
- Scripting
- Open ++include file, or all ++include files (script)
- Primitive hyperlink from selected text to online doc (script)
- Generate & Insert Trace/Debug statements (script)
- Keyboard mapping

Features on wish list not yet implemented or which need work:

- Some aspects of ASB syntax not handled properly (requires proper lexer to be written)
- Object explorer shows entire program (with includes) but doesn’t know how to link to includes
- Autocomplete
- Auto-indent
- Compiler parameters (miame.ini, switches) not specific to projects
- Scripts unable to respond to events
- Find definition of clicked on object (workaround: Find in Files)
- Find/display structure layout for clicked-on member variable
- Many menu items that don’t work or don’t apply
- File locking coordination with VUE. (Currently it detects when files have changed outside the editor, but neither will block the other.)


